// YamaIRC
// Version Alpha 5.0.0.0
//(AlphaVer.MajorUpdateVer.MinorUpdateVer.CurrentBuild)
/* Information
 Created by Yamagushi
 On 7/15/10

 Latest Noted Update
 On 12/11/10*/
 
#include "../main.h"
 
 
 
void EngineInit() {
 
	//Set Default Variables.	
	Engine.debug = 0;   //Set Engines Debugging to On.
	ylEngine.debug = Engine.debug;   //Set YamaLib Debugging to Engine's State.	
	Engine.z = 0;   //Set Engine's Z to 0.
	Engine.z2 = 0;   //Set Engine's Z to 0.
	memset(Engine.buffer, 0, sizeof(Engine.buffer)); //Clear Out Update Buffer.
	Engine.frameskip = 0;   //Set Frameskip to 0.
	Engine.numchans = 0;   //Set Number of Channels to 0.
	
	ylSetOrientation(1);   //Set Orientation to Horizontal.
	
	Network.wlan = 0;   //Set Network Status to Offline.
	Network.status = 0;   //Set Network Status to Offline.
	snprintf(Network.server, 16, "192.168.0.1");	//IRC Server IP	
	Network.port = 8001;	//Set Port to default 6667
	Network.socket = 0;   //Set Socket to 0.
	Network.maxsocket = 0;   //Set Max Socket to 0.
	Network.readbytes = 0;   //Set Read Bytes to 0.
	Network.activity = 0;   //Reset  Network Activity.
	Network.activityfs = 0;   //Reset Network Activity Frameskip.
	memset(Network.ircupdatebuff, 0, sizeof(Network.ircupdatebuff)); //Clear Out Update Buffer.
	Network.ircupdatebuffsize = 0;   //Set IRC Update Buffer Size to 0.
	memset(Network.opdelimiters, 0, sizeof(Network.opdelimiters)); //Clear Out OpDelimiters Buffer.
	sprintf(Network.opdelimiters, "@+");
	Network.numdelimiters = 2;
	
	UI.chathscroll = 0;   //Set Horizontal Chat Scroll to Off.
	UI.chatvscroll = 0;   //Set Vertical Chat Scroll to Off.
	UI.chatvpos = 100;   //Set Vertical Chat Scroll Position to 100%.
	UI.chatpos = 0;   //Set Horizontal?? Chat Scroll Position to 0.
	UI.chatoffset = 0;   //Set Chat Offset to 0.
	UI.chatcuroffset = 0;   //Set Current Chat Offset to 0.
	UI.chatlen = 0;   //Set Max Chat Length to 0.	
	UI.settingsscroll = 0;   //Set Horizontal Chat Scroll to Off.
	UI.settingspos = 0;   //Set Horizontal?? Chat Scroll Position to 0.
	UI.settingsoffset = 0;   //Set Chat Offset to 0.
	UI.settingscuroffset = 0;   //Set Current Chat Offset to 0.
	
	MainMenu.level = 0;   //Set Main Menu's Level to 0.
	MainMenu.selected = 0;   //Set Main Menu's Selected to 0.
	MainMenu.user = 0;   //Set Main Menu's User to 0.
	PauseMenu.level = 0;   //Set Pause Menu's Level to 0.
	PauseMenu.selected = 0;   //Set Pause Menu's Selected to 0.
	PauseMenu.user = 0;   //Set PauseMenu's User to 0.	
	
	Settings.isactive = 0;   //Set Settings Menu.
	Settings.kbauto = 0;   //Set Keyboard AutoComplete to Off.
	Settings.runonce = 1;	//Set Run Once Flag to off.
	Settings.fontsize = 16;	//Set Font Size
	Settings.kbbutton = 1; //Set Keyboard Button to Off. (Zune Only)
	
	sprintf(SaveData.mynickname,"YamaIRC");   //Set Initial Nickname
	sprintf(SaveData.mychannel,"#EvolvedGames");   //Set Initial Channel	
	sprintf(SaveData.myserver,"irc.freenode.net");   //Set Initial Server IP	
	sprintf(SaveData.myport,"8001");   //Set Initial Server Port
	SaveData.accesspoint = 0;	
	
	Keyboard.isactive = 0;   //Set Keyboard to Off.
	Keyboard.edited = 0;   //Set Edited to False.
	Keyboard.type = 0;   //Set Type to 0.
	memset(Keyboard.keybuffer, 0, sizeof(Keyboard.keybuffer)); //Clear Out Keyboard Buffer.
	
	//Load Up Images.
	ylLoadImagePNG(&Logo, "Logo.png");   //Logo for the Main Menu.	
	ylLoadImagePNG(&Cursor1, "Cursor1.png");   //YamaIRC Cursor (1 of 3)
	ylLoadImagePNG(&Cursor2, "Cursor2.png");   //YamaIRC Cursor (2 of 3)
	ylLoadImagePNG(&Cursor3, "Cursor3.png");   //YamaIRC Cursor (3 of 3)	
	ylLoadImagePNG(&ABCCursor, "ABCCursor.png");   //ABC 'Keyboard' Cursor (Zune Only)	
	ylLoadImagePNG(&ScrollCursor, "ScrollCursor.png");   //Vertical Scroll Cursor	
	ylLoadImagePNG(&ScrollBkg, "ScrollBkg.png");   //Background Bar to the Vertical Scroll
	ylLoadImagePNG(&Selected, "Selected.png");   //Red 'Selected' Ring
	ylLoadImagePNG(&SettingsBtn, "SettingsBtn.png");   //'Tools' Settings Button
	ylLoadImagePNG(&SettingsMore, "SettingsMore.png");   //"Plus' Settings Button
	ylLoadImagePNG(&SettingsOn, "SettingsOn.png");   //'Check' Settings Button
	ylLoadImagePNG(&SettingsOff, "SettingsOff.png");   //'X' Settings Button
	ylLoadImagePNG(&MessageCursor, "MessageCursor.png");   //'X' Settings Button 
	
	//Image Settings
	ScrollCursor.Y = ylEngine.scheight - ScrollCursor.sizeY;   //Set Position of the Scroll Cursor	
	Cursor1.X = ylEngine.scwidth - Cursor1.sizeX;   //Sets Cursor1's position.
	Cursor2.X = ylEngine.scwidth - Cursor2.sizeX;   //Sets Cursor2's position.
	Cursor3.X = ylEngine.scwidth - Cursor3.sizeX;   //Sets Cursor3's position.
	ScrollBkg.X = 12; //Set Position of the Scroll Background	
	ScrollBkg.Y = 10; //Set Position of the Scroll Background	
	
	//Load Up Font
	ylLoadFontPNG(&DefaultFont, "DefaultFont.png");   //Default Font for the Program
	Settings.fontsize = 16;   //Set Default Font Size
	ylSetFont(&DefaultFont, Settings.fontsize, colors.RED, 0);   //Set Default Font Settings
		
	memset(&MyChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Update Buffer.
	memset(&SystemChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Update Buffer.
	memset(&RawChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Update Buffer.
	memset(&DebugChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Update Buffer.
	snprintf(MyChannel.name, 513, "My Channel");	//Channel Name
	snprintf(SystemChannel.name, 513, "System Channel");	//Channel Name
	snprintf(DebugChannel.name, 513, "Debug Channel");	//Channel Name	
	snprintf(RawChannel.name, 513, "Raw Channel");	//Channel Name	
	
	PopUp.isactive = 0;   //PopUp Menu Open/Close.
	snprintf(PopUp.name, 51, "Error");   //PopUp Name.
	snprintf(PopUp.reason, 151, "Default Error Message");   //PopUp Reason.
	
	OpenChannel = &SystemChannel;	
}

void ResetEngine() { 

	raw("QUIT :YamaIRC\r\n");

	Network.status = 0;   //Set Network Status to Offline.
	ylSocketClose(Network.socket);
	Network.socket = 0;   //Set Socket to 0.
	Network.maxsocket = 0;   //Set Max Socket to 0.
	Network.readbytes = 0;   //Set Read Bytes to 0.
	Network.activity = 0;   //Reset  Network Activity.
	Network.activityfs = 0;   //Reset Network Activity Frameskip.
	memset(Network.ircupdatebuff, 0, sizeof(Network.ircupdatebuff)); //Clear Out Update Buffer.
	Network.ircupdatebuffsize = 0;   //Set IRC Update Buffer Size to 0.

	OpenChannel = NULL;

	for (Engine.z=0;Engine.z<Engine.numchans;Engine.z++) { //For Loop for Channel List.		
		for (Engine.z2=0;Engine.z2<Channel[Engine.z]->numusers;Engine.z2++) {	//For Loop for Users.	
			free(Channel[Engine.z]->user[Engine.z2]);	//Free Memory Used for Name
		}					
		free(Channel[Engine.z]); //Free Channel
		Channel[Engine.z] = NULL; //Null Out Channel	
	}
		
	Engine.z = 0;   //Set Engine's Z to 0.
	Engine.z2 = 0;   //Set Engine's Z to 0.
	memset(Engine.buffer, 0, sizeof(Engine.buffer)); //Clear Out Update Buffer.
	Engine.frameskip = 0;   //Set Frameskip to 0.
	Engine.numchans = 0;   //Set Number of Channels to 1.
	
	UI.chathscroll = 0;   //Set Horizontal Chat Scroll to Off.
	UI.chatvscroll = 0;   //Set Vertical Chat Scroll to Off.
	UI.chatvpos = 100;   //Set Vertical Chat Scroll Position to 100%.
	UI.chatpos = 0;   //Set Horizontal?? Chat Scroll Position to 0.
	UI.chatoffset = 0;   //Set Chat Offset to 0.
	UI.chatcuroffset = 0;   //Set Current Chat Offset to 0.
	UI.chatlen = 0;   //Set Max Chat Length to 0.	
	
	MainMenu.level = 0;   //Set Main Menu's Level to 0.
	MainMenu.selected = 0;   //Set Main Menu's Selected to 0.
	MainMenu.user = 0;   //Set Main Menu's User to 0.
	PauseMenu.level = 0;   //Set Pause Menu's Level to 0.
	PauseMenu.selected = 0;   //Set Pause Menu's Selected to 0.
	PauseMenu.user = 0;   //Set PauseMenu's User to 0.	
	
	Settings.isactive = 0;   //Set Settings Menu.
	Settings.kbauto = 0;   //Set Keyboard AutoComplete to Off.
	Settings.runonce = 1;	//Set Run Once Flag to off.
	Settings.fontsize = 16;	//Set Font Size
	Settings.kbbutton = 0; //Set Keyboard Button to Off. (Zune Only)
	
	Keyboard.isactive = 0;   //Set Keyboard to Off.
	Keyboard.edited = 0;   //Set Edited to False.
	Keyboard.type = 0;   //Set Type to 0.
	memset(Keyboard.keybuffer, 0, sizeof(Keyboard.keybuffer)); //Clear Out Keyboard Buffer.
	
	Settings.fontsize = 16;   //Set Default Font Size
	ylSetFont(&DefaultFont, Settings.fontsize, colors.RED, 0);   //Set Default Font Settings
	
	memset(&MyChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Struct.
	memset(&SystemChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Struct.
	memset(&RawChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Struct.
	memset(&DebugChannel, 0, sizeof(struct ChannelStruct)); //Clear Out Struct.
	ylsnprint(MyChannel.name, 513,"My Channel");	//Channel Name
	ylsnprint(SystemChannel.name, 513,"System Channel");	//Channel Name
	ylsnprint(DebugChannel.name, 513,"Debug Channel");	//Channel Name	
	ylsnprint(RawChannel.name, 513,"Raw Channel");	//Channel Name	
	
	
	
	OpenChannel = &SystemChannel;
	
}

void QuitEngine() { 
	for (Engine.z=0;Engine.z<Engine.numchans;Engine.z++) { //For Loop for Channel List.		
		for (Engine.z2=0;Engine.z2<Channel[Engine.z]->numusers;Engine.z2++) {	//For Loop for Users.	
			free(Channel[Engine.z]->user[Engine.z2]);	//Free Memory Used for Name
		}					
		free(Channel[Engine.z]); //Free Channel
		Channel[Engine.z] = NULL; //Null Out Channel	
	}
}

void LaunchPopUp(char *name, char *reason) {
	PopUp.isactive = 1;   //PopUp Menu Open/Close.
	ylsnprint(PopUp.name, 51, name);   //PopUp Name.
	ylsnprint(PopUp.reason, 151, reason);   //PopUp Reason.
}

void LogRaw(char *data) {   //Logs Raw Data to the Raw Channel. #UPGRADE#
	/*for (Engine.z = 49; Engine.z > 0; Engine.z--) {   //Loop for Moving Message Positions.
		ylsnprint(RawChannel.message[Engine.z], 513, RawChannel.message[Engine.z-1]);
	}
	ylsnprint(RawChannel.message[0], 513, data);   //Records Data.*/
} 

void LogChat(int dest, int messtype, char *messto, char *messuser1, char *messuser2, char *messuser3, char *message1, char *message2) {   //Logs Proccessed Data to the Specified Channel.


	if (dest == -1) {   //Logs Data to the Debug Channel.
		//Clear Out Old Data.
		if (DebugChannel.messtype[49]) {
			DebugChannel.messtype[49] = 0;
			if (DebugChannel.messto[49] != NULL) { free(DebugChannel.messto[49]); }
			if (DebugChannel.messuser1[49] != NULL) { free(DebugChannel.messuser1[49]); }
			if (DebugChannel.messuser2[49] != NULL) { free(DebugChannel.messuser2[49]); }
			if (DebugChannel.messuser3[49] != NULL) { free(DebugChannel.messuser3[49]); }
			if (DebugChannel.message1[49] != NULL) { free(DebugChannel.message1[49]); }
			if (DebugChannel.message2[49] != NULL) { free(DebugChannel.message2[49]); }
		}	
		
		//Move Data.
		for (Engine.z = 49; Engine.z > 0; Engine.z--) {   //Loop for Moving Message Positions.
			DebugChannel.messtype[Engine.z] = DebugChannel.messtype[Engine.z-1];
			DebugChannel.messto[Engine.z] = DebugChannel.messto[Engine.z-1];
			DebugChannel.messuser1[Engine.z] = DebugChannel.messuser1[Engine.z-1];
			DebugChannel.messuser2[Engine.z] = DebugChannel.messuser2[Engine.z-1];
			DebugChannel.messuser3[Engine.z] = DebugChannel.messuser3[Engine.z-1];
			DebugChannel.message1[Engine.z] = DebugChannel.message1[Engine.z-1];
			DebugChannel.message2[Engine.z] = DebugChannel.message2[Engine.z-1];		
		}			
		
		//Add New Data
		DebugChannel.messtype[Engine.z] = messtype;		
		if (messto != NULL) {
			DebugChannel.messto[Engine.z] = (char*)malloc(strlen(messto)+1);   //Malloc some memory for Message messto.
			if (DebugChannel.messto[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(DebugChannel.messto[Engine.z], strlen(messto)+1, messto);
		}
		else { DebugChannel.messto[Engine.z] = NULL; }		
		if (messuser1 != NULL) {
			DebugChannel.messuser1[Engine.z] = (char*)malloc(strlen(messuser1)+1);   //Malloc some memory for Message messuser1.
			if (DebugChannel.messuser1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(DebugChannel.messuser1[Engine.z], strlen(messuser1)+1, messuser1);
		}
		else { DebugChannel.messuser1[Engine.z] = NULL; }			
		if (messuser2 != NULL) {
			DebugChannel.messuser2[Engine.z] = (char*)malloc(strlen(messuser2)+1);   //Malloc some memory for Message messuser2.
			if (DebugChannel.messuser2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(DebugChannel.messuser2[Engine.z], strlen(messuser2)+1, messuser2);
		}
		else { DebugChannel.messuser2[Engine.z] = NULL; }			
		if (messuser3 != NULL) {
			DebugChannel.messuser3[Engine.z] = (char*)malloc(strlen(messuser3)+1);   //Malloc some memory for Message messuser3.
			if (DebugChannel.messuser3[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(DebugChannel.messuser3[Engine.z], strlen(messuser3)+1, messuser3);
		}
		else { DebugChannel.messuser3[Engine.z] = NULL; }		
		if (message1 != NULL) {
			DebugChannel.message1[Engine.z] = (char*)malloc(strlen(message1)+1);   //Malloc some memory for Message message1.
			if (DebugChannel.message1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(DebugChannel.message1[Engine.z], strlen(message1)+1, message1);
		}
		else { DebugChannel.message1[Engine.z] = NULL; }			
		if (message2 != NULL) {
			DebugChannel.message2[Engine.z] = (char*)malloc(strlen(message2)+1);   //Malloc some memory for Message message2.	
			if (DebugChannel.message2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(DebugChannel.message2[Engine.z], strlen(message2)+1, message2);
		}
		else { DebugChannel.message2[Engine.z] = NULL; }		
		DebugChannel.newmessage = 1;   //Set New Message Alert
		
	}
	else if (dest == -2) {   //Logs Data to the Open Channel.
		//Clear Out Old Data.
		if (OpenChannel->messtype[49]) {
			OpenChannel->messtype[49] = 0;
			if (OpenChannel->messto[49] != NULL) { free(OpenChannel->messto[49]); }
			if (OpenChannel->messuser1[49] != NULL) { free(OpenChannel->messuser1[49]); }
			if (OpenChannel->messuser2[49] != NULL) { free(OpenChannel->messuser2[49]); }
			if (OpenChannel->messuser3[49] != NULL) { free(OpenChannel->messuser3[49]); }
			if (OpenChannel->message1[49] != NULL) { free(OpenChannel->message1[49]); }
			if (OpenChannel->message2[49] != NULL) { free(OpenChannel->message2[49]); }
		}	
		
		//Move Data.
		for (Engine.z = 49; Engine.z > 0; Engine.z--) {   //Loop for Moving Message Positions.
			OpenChannel->messtype[Engine.z] = OpenChannel->messtype[Engine.z-1];
			OpenChannel->messto[Engine.z] = OpenChannel->messto[Engine.z-1];
			OpenChannel->messuser1[Engine.z] = OpenChannel->messuser1[Engine.z-1];
			OpenChannel->messuser2[Engine.z] = OpenChannel->messuser2[Engine.z-1];
			OpenChannel->messuser3[Engine.z] = OpenChannel->messuser3[Engine.z-1];
			OpenChannel->message1[Engine.z] = OpenChannel->message1[Engine.z-1];
			OpenChannel->message2[Engine.z] = OpenChannel->message2[Engine.z-1];		
		}			
		
		//Add New Data
		OpenChannel->messtype[Engine.z] = messtype;		
		if (messto != NULL) {
			OpenChannel->messto[Engine.z] = (char*)malloc(strlen(messto)+1);	//Malloc some memory for Message messto.
			if (OpenChannel->messto[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(OpenChannel->messto[Engine.z], strlen(messto)+1, messto); 
		}
		else { OpenChannel->messto[Engine.z] = NULL; }		
		if (messuser1 != NULL) {
			OpenChannel->messuser1[Engine.z] = (char*)malloc(strlen(messuser1)+1);	//Malloc some memory for Message messuser1.
			if (OpenChannel->messuser1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(OpenChannel->messuser1[Engine.z], strlen(messuser1)+1, messuser1);
		}
		else { OpenChannel->messuser1[Engine.z] = NULL; }			
		if (messuser2 != NULL) {
			OpenChannel->messuser2[Engine.z] = (char*)malloc(strlen(messuser2)+1);	//Malloc some memory for Message messuser2.
			if (OpenChannel->messuser2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(OpenChannel->messuser2[Engine.z], strlen(messuser2)+1, messuser2);
		}
		else { OpenChannel->messuser2[Engine.z] = NULL; }			
		if (messuser3 != NULL) {
			OpenChannel->messuser3[Engine.z] = (char*)malloc(strlen(messuser3)+1);	//Malloc some memory for Message messuser3.
			if (OpenChannel->messuser3[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(OpenChannel->messuser3[Engine.z], strlen(messuser3)+1, messuser3);
		}
		else { OpenChannel->messuser3[Engine.z] = NULL; }		
		if (message1 != NULL) {
			OpenChannel->message1[Engine.z] = (char*)malloc(strlen(message1)+1);	//Malloc some memory for Message message1.
			if (OpenChannel->message1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(OpenChannel->message1[Engine.z], strlen(message1)+1, message1);
		}
		else { OpenChannel->message1[Engine.z] = NULL; }			
		if (message2 != NULL) {
			OpenChannel->message2[Engine.z] = (char*)malloc(strlen(message2)+1);	//Malloc some memory for Message message2.	
			if (OpenChannel->message2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(OpenChannel->message2[Engine.z], strlen(message2)+1, message2);	
		}
		else { OpenChannel->message2[Engine.z] = NULL; }		
		OpenChannel->newmessage = 1;   //Set New Message Alert
		
	}
	else if (dest == -3) {   //Logs Data to the System Channel.
		//Clear Out Old Data.
		if (SystemChannel.messtype[49]) {
			SystemChannel.messtype[49] = 0;
			if (SystemChannel.messto[49] != NULL) { free(SystemChannel.messto[49]); }
			if (SystemChannel.messuser1[49] != NULL) { free(SystemChannel.messuser1[49]); }
			if (SystemChannel.messuser2[49] != NULL) { free(SystemChannel.messuser2[49]); }
			if (SystemChannel.messuser3[49] != NULL) { free(SystemChannel.messuser3[49]); }
			if (SystemChannel.message1[49] != NULL) { free(SystemChannel.message1[49]); }
			if (SystemChannel.message2[49] != NULL) { free(SystemChannel.message2[49]); }
		}	
		
		//Move Data.
		for (Engine.z = 49; Engine.z > 0; Engine.z--) {   //Loop for Moving Message Positions.
			SystemChannel.messtype[Engine.z] = SystemChannel.messtype[Engine.z-1];
			SystemChannel.messto[Engine.z] = SystemChannel.messto[Engine.z-1];
			SystemChannel.messuser1[Engine.z] = SystemChannel.messuser1[Engine.z-1];
			SystemChannel.messuser2[Engine.z] = SystemChannel.messuser2[Engine.z-1];
			SystemChannel.messuser3[Engine.z] = SystemChannel.messuser3[Engine.z-1];
			SystemChannel.message1[Engine.z] = SystemChannel.message1[Engine.z-1];
			SystemChannel.message2[Engine.z] = SystemChannel.message2[Engine.z-1];		
		}			
		
		//Add New Data
		SystemChannel.messtype[Engine.z] = messtype;		
		if (messto != NULL) {
			SystemChannel.messto[Engine.z] = (char*)malloc(strlen(messto)+1);	//Malloc some memory for Message messto.
			if (SystemChannel.messto[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(SystemChannel.messto[Engine.z], strlen(messto)+1, messto);
		}
		else { SystemChannel.messto[Engine.z] = NULL; }		
		if (messuser1 != NULL) {
			SystemChannel.messuser1[Engine.z] = (char*)malloc(strlen(messuser1)+1);	//Malloc some memory for Message messuser1.
			if (SystemChannel.messuser1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(SystemChannel.messuser1[Engine.z], strlen(messuser1)+1, messuser1);
		}
		else { SystemChannel.messuser1[Engine.z] = NULL; }			
		if (messuser2 != NULL) {
			SystemChannel.messuser2[Engine.z] = (char*)malloc(strlen(messuser2)+1);	//Malloc some memory for Message messuser2.
			if (SystemChannel.messuser2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(SystemChannel.messuser2[Engine.z], strlen(messuser2)+1, messuser2);
		}
		else { SystemChannel.messuser2[Engine.z] = NULL; }			
		if (messuser3 != NULL) {
			SystemChannel.messuser3[Engine.z] = (char*)malloc(strlen(messuser3)+1);	//Malloc some memory for Message messuser3.
			if (SystemChannel.messuser3[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(SystemChannel.messuser3[Engine.z], strlen(messuser3)+1, messuser3);
		}
		else { SystemChannel.messuser3[Engine.z] = NULL; }		
		if (message1 != NULL) {
			SystemChannel.message1[Engine.z] = (char*)malloc(strlen(message1)+1);	//Malloc some memory for Message message1.
			if (SystemChannel.message1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(SystemChannel.message1[Engine.z], strlen(message1)+1, message1);
		}
		else { SystemChannel.message1[Engine.z] = NULL; }			
		if (message2 != NULL) {
			SystemChannel.message2[Engine.z] = (char*)malloc(strlen(message2)+1);	//Malloc some memory for Message message2.
			if (SystemChannel.message2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.	
			ylsnprint(SystemChannel.message2[Engine.z], strlen(message2)+1, message2);	
		}
		else { SystemChannel.message2[Engine.z] = NULL; }		
		SystemChannel.newmessage = 1;   //Set New Message Alert
		
	}
	else if (dest == -4) {   //Logs Data to the MyChannel.
		//Clear Out Old Data.
		if (MyChannel.messtype[49]) {
			MyChannel.messtype[49] = 0;
			if (MyChannel.messto[49] != NULL) { free(MyChannel.messto[49]); }
			if (MyChannel.messuser1[49] != NULL) { free(MyChannel.messuser1[49]); }
			if (MyChannel.messuser2[49] != NULL) { free(MyChannel.messuser2[49]); }
			if (MyChannel.messuser3[49] != NULL) { free(MyChannel.messuser3[49]); }
			if (MyChannel.message1[49] != NULL) { free(MyChannel.message1[49]); }
			if (MyChannel.message2[49] != NULL) { free(MyChannel.message2[49]); }
		}	
		
		//Move Data.
		for (Engine.z = 49; Engine.z > 0; Engine.z--) {   //Loop for Moving Message Positions.
			MyChannel.messtype[Engine.z] = MyChannel.messtype[Engine.z-1];
			MyChannel.messto[Engine.z] = MyChannel.messto[Engine.z-1];
			MyChannel.messuser1[Engine.z] = MyChannel.messuser1[Engine.z-1];
			MyChannel.messuser2[Engine.z] = MyChannel.messuser2[Engine.z-1];
			MyChannel.messuser3[Engine.z] = MyChannel.messuser3[Engine.z-1];
			MyChannel.message1[Engine.z] = MyChannel.message1[Engine.z-1];
			MyChannel.message2[Engine.z] = MyChannel.message2[Engine.z-1];		
		}			
		
		
		//Add New Data
		MyChannel.messtype[Engine.z] = messtype;		
		if (messto != NULL) {
			MyChannel.messto[Engine.z] = (char*)malloc(strlen(messto)+1);	//Malloc some memory for Message messto.
			if (MyChannel.messto[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(MyChannel.messto[Engine.z], strlen(messto)+1, messto);
		}
		else { MyChannel.messto[Engine.z] = NULL; }		
		if (messuser1 != NULL) {
			MyChannel.messuser1[Engine.z] = (char*)malloc(strlen(messuser1)+1);	//Malloc some memory for Message messuser1.
			if (MyChannel.messuser1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(MyChannel.messuser1[Engine.z], strlen(messuser1)+1, messuser1);
		}
		else { MyChannel.messuser1[Engine.z] = NULL; }			
		if (messuser2 != NULL) {
			MyChannel.messuser2[Engine.z] = (char*)malloc(strlen(messuser2)+1);	//Malloc some memory for Message messuser2.
			if (MyChannel.messuser2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(MyChannel.messuser2[Engine.z], strlen(messuser2)+1, messuser2);
		}
		else { MyChannel.messuser2[Engine.z] = NULL; }			
		if (messuser3 != NULL) {
			MyChannel.messuser3[Engine.z] = (char*)malloc(strlen(messuser3)+1);	//Malloc some memory for Message messuser3.
			if (MyChannel.messuser3[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(MyChannel.messuser3[Engine.z], strlen(messuser3)+1, messuser3);
		}
		else { MyChannel.messuser3[Engine.z] = NULL; }		
		if (message1 != NULL) {
			MyChannel.message1[Engine.z] = (char*)malloc(strlen(message1)+1);	//Malloc some memory for Message message1.
			if (MyChannel.message1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(MyChannel.message1[Engine.z], strlen(message1)+1, message1);
		}
		else { MyChannel.message1[Engine.z] = NULL; }			
		if (message2 != NULL) {
			MyChannel.message2[Engine.z] = (char*)malloc(strlen(message2)+1);	//Malloc some memory for Message message2.
			if (MyChannel.message2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.	
			ylsnprint(MyChannel.message2[Engine.z], strlen(message2)+1, message2);	
		}
		else { MyChannel.message2[Engine.z] = NULL; }		
		MyChannel.newmessage = 1;   //Set New Message Alert
		
	}
	else {   //Logs Data to the Destination Channel.
		//Clear Out Old Data.
		if (Channel[dest]->messtype[49]) {
			Channel[dest]->messtype[49] = 0;
			if (Channel[dest]->messto[49] != NULL) { free(Channel[dest]->messto[49]); }
			if (Channel[dest]->messuser1[49] != NULL) { free(Channel[dest]->messuser1[49]); }
			if (Channel[dest]->messuser2[49] != NULL) { free(Channel[dest]->messuser2[49]); }
			if (Channel[dest]->messuser3[49] != NULL) { free(Channel[dest]->messuser3[49]); }
			if (Channel[dest]->message1[49] != NULL) { free(Channel[dest]->message1[49]); }
			if (Channel[dest]->message2[49] != NULL) { free(Channel[dest]->message2[49]); }
		}	
		
		//Move Data.
		for (Engine.z = 49; Engine.z > 0; Engine.z--) {   //Loop for Moving Message Positions.
			Channel[dest]->messtype[Engine.z] = Channel[dest]->messtype[Engine.z-1];
			Channel[dest]->messto[Engine.z] = Channel[dest]->messto[Engine.z-1];
			Channel[dest]->messuser1[Engine.z] = Channel[dest]->messuser1[Engine.z-1];
			Channel[dest]->messuser2[Engine.z] = Channel[dest]->messuser2[Engine.z-1];
			Channel[dest]->messuser3[Engine.z] = Channel[dest]->messuser3[Engine.z-1];
			Channel[dest]->message1[Engine.z] = Channel[dest]->message1[Engine.z-1];
			Channel[dest]->message2[Engine.z] = Channel[dest]->message2[Engine.z-1];		
		}			
		
		//Add New Data
		Channel[dest]->messtype[Engine.z] = messtype;		
		if (messto != NULL) {
			Channel[dest]->messto[Engine.z] = (char*)malloc(strlen(messto)+1);	//Malloc some memory for Message messto.
			if (Channel[dest]->messto[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(Channel[dest]->messto[Engine.z], strlen(messto)+1, messto);
		}
		else { Channel[dest]->messto[Engine.z] = NULL; }		
		if (messuser1 != NULL) {
			Channel[dest]->messuser1[Engine.z] = (char*)malloc(strlen(messuser1)+1);	//Malloc some memory for Message messuser1.
			if (Channel[dest]->messuser1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(Channel[dest]->messuser1[Engine.z], strlen(messuser1)+1, messuser1);
		}
		else { Channel[dest]->messuser1[Engine.z] = NULL; }			
		if (messuser2 != NULL) {
			Channel[dest]->messuser2[Engine.z] = (char*)malloc(strlen(messuser2)+1);	//Malloc some memory for Message messuser2.
			if (Channel[dest]->messuser2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(Channel[dest]->messuser2[Engine.z], strlen(messuser2)+1, messuser2);
		}
		else { Channel[dest]->messuser2[Engine.z] = NULL; }			
		if (messuser3 != NULL) {
			Channel[dest]->messuser3[Engine.z] = (char*)malloc(strlen(messuser3)+1);	//Malloc some memory for Message messuser3.
			if (Channel[dest]->messuser3[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(Channel[dest]->messuser3[Engine.z], strlen(messuser3)+1, messuser3);
		}
		else { Channel[dest]->messuser3[Engine.z] = NULL; }		
		if (message1 != NULL) {
			Channel[dest]->message1[Engine.z] = (char*)malloc(strlen(message1)+1);	//Malloc some memory for Message message1.
			if (Channel[dest]->message1[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(Channel[dest]->message1[Engine.z], strlen(message1)+1, message1);
		}
		else { Channel[dest]->message1[Engine.z] = NULL; }			
		if (message2 != NULL) {
			Channel[dest]->message2[Engine.z] = (char*)malloc(strlen(message2)+1);	//Malloc some memory for Message message2.	
			if (Channel[dest]->message2[Engine.z] == NULL) { CODERED("LOGCHAT"); }   //BSOD if failed.
			ylsnprint(Channel[dest]->message2[Engine.z], strlen(message2)+1, message2);	
		}
		else { Channel[dest]->message2[Engine.z] = NULL; }		
		Channel[dest]->newmessage = 1;   //Set New Message Alert
	}
} 

void raw(char *fmt, ...) {
	int listen;
	char sbuf[512];
    va_list ap;
    va_start(ap, fmt);
    vsnprintf(sbuf, 512, fmt, ap);
    va_end(ap);	
	listen = ylSocketSend(Network.socket, sbuf, strlen(sbuf));	
	if (!listen) {
		LaunchPopUp("i11", "Disconnected from Network.");
	}
}

void IRCLogin() {    	
		ylStartDrawing();   //Start Current Frame.		
		ylClearScreen();   //Clear Screen for New Frame.	
		//Draw PopUp Name	
		ylSetFont(&DefaultFont, 16, colors.RED, 1);
		ylDrawString(&DefaultFont, "Connecting to Server", 240, 110);	
		ylDrawString(&DefaultFont, "If your reading all this then", 240, 130);	
		ylDrawString(&DefaultFont, "its probably a bad port.", 240, 150);	
		ylEndDrawing();   //End Drawing.
		ylSyncFrame();   //End Current Frame.	
	//Create Socket.
	Network.socket = ylSocketCreate();
	if (Network.socket > Network.maxsocket) { Network.maxsocket = Network.socket; }
	if (!Network.socket) {
		Network.status = 0;
		LaunchPopUp("y01", "Failed to Create Socket.");
	}
	else {	
		int connected;
		connected = ylSocketConnect(Network.socket, Network.server, Network.port);
		if (!connected) {
			Network.status = 0;
			LaunchPopUp("y02", "Failed to connect to Server");
		}
		else {		
			Network.status = 1;	
			ylSetNonBlocking(Network.socket);
			raw("NICK %s\r\n",SaveData.mynickname);
			raw("USER %s 0 * :YamaIRC Beta 1\r\n",SaveData.mynickname);
		}	
	}	
}

int IRCUpdate() {	
	char Recbuf[512];
	char Middlebuf[1024];
	char Middlebuf2[1024];
	char Endbuf[512];
	int Posbuf = 0;
	int Bufsize = 0;
	int Recsize = 512;	
	char debugstr[25];
	memset(Recbuf, 0, sizeof(Recbuf));
	memset(Middlebuf, 0, sizeof(Middlebuf));
	memset(Middlebuf2, 0, sizeof(Middlebuf2));
	memset(Endbuf, 0, sizeof(Endbuf));	
	Network.readbytes = 0;
	Network.readbytes = ylSocketReceive(Network.socket, Recbuf, Recsize);		
	if ((Network.readbytes == -1) && (Bufsize == 0)) { return 0;}
	if (!Network.readbytes) {
		Network.status = 0; 
		ylSocketClose(Network.socket);
		Network.socket = 0;
		LaunchPopUp("y11", "Disconnected from Network.");
		return 0;
	} 
	else if (Network.readbytes > 0) {
		int i;			
		Network.activity = 1;   //Signal Network Activity.
		Network.activityfs = 0;   //Reset Network Activity Frameskip.
		ylsnprint(Middlebuf, 1024, Network.ircupdatebuff);
		strncat(Middlebuf, Recbuf, 1024);
		Bufsize = Network.ircupdatebuffsize + Network.readbytes;
		memset(Network.ircupdatebuff, 0, sizeof(Network.ircupdatebuff));
		Network.ircupdatebuffsize = 0;
		for (i = 0; i < Bufsize; i++) {	
			Endbuf[i] = Middlebuf[i];			
			/*ylStartDrawing();
			oslClearScreen(RGB(0,255,0));
			sprintf(debugstr, "i-%i,b-%i", i, Bufsize);
			ylSetFont(&DefaultFont, 16, colors.WHITE, 0);		
			ylDrawString(&DefaultFont, debugstr, 10, 136);
			ylEndDrawing();
			ylSyncFrame();	*/		
			if ((i > 0) && (Middlebuf[i] == '\r') && (Middlebuf[i+1] == '\n')) {
				Endbuf[i] = '\0';
				ParseIncoming(Endbuf);
				memset(Endbuf, 0, sizeof(Endbuf));
				ylsnprint(Middlebuf2, 1024, Middlebuf+i+2);	
				if (i+2 == Bufsize) {
					Bufsize = -1;
				}				
				else {
					Bufsize = Bufsize-(i+2);
					ylsnprint(Middlebuf, 1024, Middlebuf2);
					i=-1;
				}
			}
			else if (i+1 == Bufsize) {
				Endbuf[i+1] = '\0';
				ylsnprint(Network.ircupdatebuff, 1024, Endbuf);
				memset(Endbuf, 0, sizeof(Endbuf));
				Network.ircupdatebuffsize = i+1;
				return 1;
			}
		}		
	}
	return 1;
}