//YamaLib
//Version Alpha 0.1.0.0
//(AlphaVer.MajorUpdateVer.MinorUpdateVer.CurrentBuild)
/* Information
 Created by Yamagushi
 On 7/15/10

 Latest Update
 On 7/15/10*/
 

#include "YamaLib.h"

///////////////////////
// Platform Specific //
///////////////////////

void ylPSPNetConf() {
	#ifdef _PSP
	if (ylPSPNetConfig == 0) {
		memset(&ylNetData, 0, sizeof(ylNetData));
		ylNetData.base.size = sizeof(ylNetData);
		ylNetData.base.language = PSP_SYSTEMPARAM_LANGUAGE_ENGLISH;
		ylNetData.base.buttonSwap = PSP_UTILITY_ACCEPT_CROSS;
		ylNetData.base.graphicsThread = 0x11;
		ylNetData.base.accessThread = 0x13;
		ylNetData.base.fontThread = 0x12;
		ylNetData.base.soundThread = 0x10;
		ylNetData.action = PSP_NETCONF_ACTION_CONNECTAP;
		
		memset(&adhocparam, 0, sizeof(adhocparam));
		ylNetData.adhocparam = &adhocparam;

		sceUtilityNetconfInitStart(&ylNetData);
		ylPSPNetConfig = 1;
	}
	#endif
}




#ifdef PlatformPSP
void Sleep(int milliseconds) {
	sceKernelDelayThread(milliseconds*1000);
}
//Updates Timing and FPS.
void ylUpdateTime(float FpsLimit) {

	Time.totalframes++;
	Time.frames++;
	
	if(sceRtcGetCurrentTick(&Time.new) != 0) { Time.new = 0; }

	if(Time.old == 0)
	{
		Time.old = Time.new;

		Time.resolution = sceRtcGetTickResolution();
	}	
	
	Time.ticks = Time.new-Time.old;
	
	if(Time.ticks > 0)
	{
		Time.fps = (float)Time.frames * Time.resolution / (float)Time.ticks;

		if (FpsLimit) {
			if (((1000000.0f/FpsLimit) - (1000000.0f/Time.fps)) > 0.0f) {
				sceKernelDelayThread(((1000000.0f/FpsLimit) - (1000000.0f/Time.fps)));
				
				sceRtcGetCurrentTick(&Time.new);
				Time.ticks = Time.new-Time.old;
				
				Time.fps = (float)Time.frames * Time.resolution / (float)Time.ticks;
			}
		}
		
		Time.frames = 0;
		Time.old = Time.new;
	}

}
//Callback for YNconnectToAP
int YNconnectAPCallback(int state) {
	oslStartDrawing();
	oslClearScreen(0);		
	oslPrintf_xy(240, 122, "Connecting to AP...");
	oslPrintf_xy(240, 137, "State: %i", state);	
	oslEndDrawing();
	oslSyncFrame();
	return 0;
}
int YNconnectToAP(int YNconToAPconfig) {
	int result = 0;	
	char YNmyip[30] = "";
	
    oslStartDrawing();	
	oslClearScreen(0);	
	oslPrintf_xy(240, 122, "Connecting to AP...");
    oslEndDrawing();
    oslSyncFrame();
	if (!oslIsWlanConnected()) {
		result = oslConnectToAP(YNconToAPconfig, 30, YNconnectAPCallback);
		if (!result) {
			oslGetIPaddress(YNmyip);
			oslStartDrawing();
			oslClearScreen(0);					
			oslPrintf_xy(240, 122, "Connected to AP!");				
			oslPrintf_xy(240, 137, "Local IP: %s!",YNmyip);
			oslEndDrawing();
			oslSyncFrame();
			return 1;
		} 
		else {
			oslStartDrawing();
			oslClearScreen(0);	
			oslPrintf_xy(240, 137, "Error connecting to AP!");
			oslEndDrawing();
			oslSyncFrame();
			sceKernelDelayThread(3*1000000);
			return 0;
		}
	}
    return 0;
}
#endif
#ifdef PlatformZune
// This won't be necessary with the next OpenZDK! 
extern __inline BOOL ZDKExt_ExitRequested() {
	static HANDLE evt = NULL;
	if (!evt)
	{
		evt = OpenEvent(EVENT_ALL_ACCESS, FALSE, L"ZAM/AppExitEvent");
		if (!evt)
			return FALSE;
	}
	return (WaitForSingleObject(evt, 0) == WAIT_OBJECT_0);
}

// Enables or disables reboot-on-exit via an ugly registry kludge
static HRESULT ConfigureReboot(BOOL enabled);
static HRESULT ConfigureReboot(BOOL enabled) {
	LONG result = ERROR_SUCCESS;
	HKEY key = NULL;
	DWORD vflags = enabled ? 0x800000 : 0x10000;
	DWORD vdefault = enabled ? 4 : 0;
	if (result == ERROR_SUCCESS)
		result = RegOpenKeyEx(HKEY_LOCAL_MACHINE, L"System\\CurrentControlSet\\Control\\Power\\State\\Reboot", 0, 0, &key);
	if (result == ERROR_SUCCESS)
		result = RegSetValueEx(key, L"Flags", 0, REG_DWORD, (BYTE *)&vflags, sizeof(DWORD));
	if (result == ERROR_SUCCESS)
		result = RegSetValueEx(key, L"Default", 0, REG_DWORD, (BYTE *)&vdefault, sizeof(DWORD));
	if (key)
		RegCloseKey(key);
	return HRESULT_FROM_WIN32(result);
}
#endif


/////////////
// System //
////////////


void CODERED(char *reason) {
	#ifdef PlatformPSP
	while(1) {
		oslStartDrawing();
		oslClearScreen(RGB(0,0,255));		
		oslPrintf_xy(220, 122, "We Ran Out of MegaBites! Oh No!");
		oslPrintf_xy(220, 137, "Reason: %s", reason);	
		oslEndDrawing();
		oslSyncFrame();
	}
	#endif
}

int ylSetupCallbacks() {
	#ifdef PlatformZune
	 //Enable Reboot
	 ConfigureReboot(TRUE);		
	 return 1;
	#endif
	#ifdef PlatformPSP
     //no longer needed with OSlib
	 return 1;
	#endif
}

void InitYamaLib() {
	
	YL_QUIT = 0;
	ylEngine.debug = 0;
	
	//Set Colors
	#ifdef PlatformZune
	 colors.RED = 0xFFFF0000;
	 colors.GREEN = 0xFF00FF00;
	 colors.BLUE = 0xFF0000FF;	
	 colors.YELLOW = 0xFFFFFF00;
	 colors.ORANGE = 0xFFFF8000;
	 colors.BROWN = 0xFF965A3C;
	 colors.PURPLE = 0xFF8000FF;
	 colors.WHITE = 0xFFFFFFFF;
	 colors.LITEGRAY = 0xFFBBBBBB;
	 colors.GRAY = 0xFF888888;
	 colors.DARKGRAY = 0xFF555555;	
	 colors.BLACK = 0xFF000000;
	 colors.filterBLACK = 0xDD000000;
	#endif
	#ifdef PlatformPSP
	 colors.RED = 0xFF0000FF;
	 colors.GREEN = 0xFF00FF00;
	 colors.BLUE = 0xFFFF0000;	
	 colors.YELLOW = 0xFF00FFFF;
	 colors.ORANGE = 0xFF0080FF;
	 colors.BROWN = 0xFF3C5A96;
	 colors.PURPLE = 0xFFFF0080;
	 colors.WHITE = 0xFFFFFFFF;
	 colors.LITEGRAY = 0xFFBBBBBB;
	 colors.GRAY = 0xFF888888;
	 colors.DARKGRAY = 0xFF555555;	
	 colors.BLACK = 0xFF000000;
	 colors.filterBLACK = 0xDD000000;
	#endif

	#ifdef PlatformZune
	 iMode=1;
	 ZDKDisplay_Initialize();	 
     YNnoblocktv.tv_sec = 0;
     YNnoblocktv.tv_usec = 100;
	#endif
	#ifdef PlatformPSP
	 //Ready controls
	 sceCtrlSetSamplingCycle(0);
	 sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	 //Initialization of the Oslib Library
	 oslInit(0);
	 //Initialization of the Graphics
	 oslInitGfx(OSL_PF_8888, 1);
	 //Initialization of the Text Console
	 oslInitConsole();	
	 //Set quit on load fail.
     oslSetQuitOnLoadFailure(1);
	 //Init oslNet
	 oslNetInit();
	 YNaccesspoint = 0;
	 YNnumconfigs = oslGetNetConfigs(YNconfigs);
	#endif
}

void ylSetOrientation(int orientation) {
	if (orientation == 0) {	
		ylEngine.horizontal = 0;
 		#ifdef PlatformZune
		 ZDKSystem_SetOrientation(0);
		#endif
 		ylEngine.scheight = 480;
 		ylEngine.scwidth = 272;
 	}
	else if (orientation == 1) {	
 	
 		ylEngine.horizontal = 1;
 		#ifdef PlatformZune
		 ZDKSystem_SetOrientation(2);
		#endif
 		ylEngine.scheight = 272;
 		ylEngine.scwidth = 480;
 	}
 	else {		
 		ylEngine.horizontal = 0;
 		#ifdef PlatformZune
		 ZDKSystem_SetOrientation(0);
		#endif
 		ylEngine.scheight = 480;
 		ylEngine.scwidth = 272;
	}
}

void UnitYamaLib() {

	#ifdef PlatformZune
	 ZDKDisplay_Cleanup();
	 ConfigureReboot(FALSE);
	#endif
	#ifdef PlatformPSP
     oslNetTerm();
	 oslEndGfx();
	 oslQuit();
	#endif
}

void ylsnprint(char *out, int max, char *in) {
	strncpy(out, in, max);	
	out[max-1] = '\0';
}


////////////////////
// Loading Images //
////////////////////

int ylLoadImagePNG(YL_IMAGE *image, char *filename) {

	#ifdef PlatformZune	
	 HIMAGE imageh = NULL;
	 HTEXTURE tex = NULL;
	 ZDK_RECT rect;
	 ZDK_TEXTURE_LOCK_INFO lockinfo;
	 char releaselocation[128] = "\\gametitle\\584E07D1\\Content\\";
	 char debuglocation[128] = "\\Flash2\\debug\\YamaIRC\\";
	 wchar_t location[256];
	 
	 if (ylEngine.debug) {
		 strcat(debuglocation, filename);
		 mbstowcs(location, debuglocation, sizeof(location));
	 } else {
		 strcat(releaselocation, filename);
		 mbstowcs(location, releaselocation, sizeof(location));
	 }
	
	 image->location = location;
	
	 /* load the image */
	 ZDKImage_CreateImageFromFile(image->location, &imageh);
	 ZDKImage_GetImageSize(imageh, &image->sizeX, &image->sizeY);
	 /* create the Texture */
	 ZDKDisplay_CreateTexture(image->sizeX, image->sizeY, &tex);
	 /* lock the Texture */
	 rect.Left = 0;
	 rect.Top = 0;
	 rect.Right = image->sizeX;
	 rect.Bottom = image->sizeY;
	 ZDKDisplay_TextureLockRect(tex, &lockinfo, &rect, TEXTURE_LOCK_DISCARD);
	 /* dump the image into the Texture */
	 ZDKImage_GetImageData(imageh, lockinfo.Buffer, image->sizeX * image->sizeY * 4);
	 ZDKDisplay_TextureUnlockRect(tex);
	 /* clean up */
	 ZDKImage_ReleaseImage(imageh);
	 imageh = NULL;
	 image->Texture = tex;
	 image->X = 0;
	 image->Y = 0;
	 image->centerX = image->sizeX/2;
	 image->centerY = image->sizeY/2;
	 image->R = 0;
	
	 return 1;
	#endif
	#ifdef PlatformPSP	
	 char releaselocation[128] = "Resources/";
	 char debuglocation[128] = "../Resources/";
	 if (ylEngine.debug) {
		strcat(debuglocation, filename);
		snprintf(image->location, 128, debuglocation);
	 } else {
	 	strcat(releaselocation, filename);
		snprintf(image->location, 128, releaselocation);
	 }
	
	 image->Texture = oslLoadImageFilePNG(image->location, OSL_IN_RAM, OSL_PF_8888);
	 if (!image->Texture) {
		 //Image load failed
		 return 0;
	 }
	 image->sizeX = image->Texture->sizeX;
	 image->sizeY = image->Texture->sizeY;	
	 image->Texture->centerX = (image->Texture->sizeX / 2);
	 image->Texture->centerY = (image->Texture->sizeY / 2);
	 image->X = 0;
	 image->Y = 0;
	 image->centerX = image->sizeX/2;
	 image->centerY = image->sizeY/2;
	 image->R = 0;
	
	 return 1;
	#endif 
}

int ylLoadFontPNG(YL_FONT *font, char *filename) {
	#ifdef PlatformZune
	 HIMAGE imageh = NULL;
	 HTEXTURE tex = NULL;
	 ZDK_RECT rect;
	 ZDK_TEXTURE_LOCK_INFO lockinfo;
	 char releaselocation[128] = "\\gametitle\\584E07D1\\Content\\";
	 char debuglocation[128] = "\\Flash2\\debug\\YamaIRC\\";
	 wchar_t location[256];	
	 if (ylEngine.debug) {
		 strcat(debuglocation, filename);
		 mbstowcs(location, debuglocation, sizeof(location));
	 } else {
		 strcat(releaselocation, filename);
		 mbstowcs(location, releaselocation, sizeof(location));
	 }
	 font->location = location;
	 /* load the font */
	 ZDKImage_CreateImageFromFile(font->location, &imageh);
	 ZDKImage_GetImageSize(imageh, &font->sizeX, &font->sizeY);
	 /* create the Texture */
	 ZDKDisplay_CreateTexture(font->sizeX, font->sizeY, &tex);
	 /* lock the Texture */
	 rect.Left = 0;
	 rect.Top = 0;
	 rect.Right = font->sizeX;
	 rect.Bottom = font->sizeY;
	 ZDKDisplay_TextureLockRect(tex, &lockinfo, &rect, TEXTURE_LOCK_DISCARD);
	 /* dump the font into the Texture */
	 ZDKImage_GetImageData(imageh, lockinfo.Buffer, font->sizeX * font->sizeY * 4);
	 ZDKDisplay_TextureUnlockRect(tex);
	 /* clean up */
	 ZDKImage_ReleaseImage(imageh);
	 imageh = NULL;
	 font->Texture = tex;
	 font->X = 0;
	 font->Y = 0;
	 font->centerX = font->sizeX/2;
	 font->centerY = font->sizeY/2;	
	 font->charWidth = font->sizeX/16;
	 font->charHeight = font->sizeY/8;
	 font->fontWidth = font->charWidth;
	 font->fontHeight = font->charHeight;
	 font->spacing = 0;
	
	 return 1;
	#endif
	#ifdef PlatformPSP
	
	 char releaselocation[128] = "Resources/";
	 char debuglocation[128] = "../Resources/";
	 
	 if (ylEngine.debug) {
		strcat(debuglocation, filename);
		snprintf(font->location, 128, debuglocation);
	 } else {
	 	strcat(releaselocation, filename);
		snprintf(font->location, 128, releaselocation);
	 }
	 font->Texture = oslLoadImageFilePNG(font->location, OSL_IN_RAM, OSL_PF_8888);
	 if (!font->Texture) {
		 //font load failed
		 return 0;
	 }
	 font->sizeX = font->Texture->sizeX;  //494
	 font->sizeY = font->Texture->sizeY;	//160
	 font->Texture->centerX = (font->Texture->sizeX / 2);
	 font->Texture->centerY = (font->Texture->sizeY / 2);
	 font->X = 0;
	 font->Y = 0;
	 font->centerX = font->sizeX/2; //247
	 font->centerY = font->sizeY/2;	//80
	 font->charWidth = font->sizeX/16; //26
	 font->charHeight = font->sizeY/8; //32
	 font->fontWidth = font->charWidth;  //26
	 font->fontHeight = font->charHeight; //32
	 font->spacing = 0;

	 return 1;
	#endif
}



//////////////////////
// Start/End Frames //
//////////////////////
void ylEndDrawing() {
	#ifdef PlatformZune
	 ZDKDisplay_EndScene();
	#endif	
	#ifdef PlatformPSP
	 oslEndDrawing();			
	 if (ylPSPNetConfig) {
		switch(sceUtilityNetconfGetStatus()) {
			case PSP_UTILITY_DIALOG_NONE:
				break;

			case PSP_UTILITY_DIALOG_VISIBLE:
				sceUtilityNetconfUpdate(1);
				break;

			case PSP_UTILITY_DIALOG_QUIT:
				sceUtilityNetconfShutdownStart();
				break;
				
			case PSP_UTILITY_DIALOG_FINISHED:
				ylPSPNetConfig = 0;
				break;
			default:
				break;
		}
	 }						
	#endif		
}
void ylClearScreen() {	
	#ifdef PlatformZune
	 ZDKDisplay_Clear(colors.BLACK);
	#endif
	#ifdef PlatformPSP
	 oslClearScreen(colors.BLACK);
	#endif	
}

////////////////////
// Draw Rectangle //
////////////////////
 void ylDrawRect(int x, int y, int width, int height, DWORD color) {	
 
	#ifdef PlatformZune
	 unsigned char buffer[4];
	 int size = sizeof(buffer);
     ZDK_SPRITE sprite;
	 ZDK_RECT rect = {0, 0, 1, 1};
	 HTEXTURE emptytexture = NULL;	

	 memset(buffer, 0xFFFFFFFF, size);

	 ZDKDisplay_CreateTexture(1, 1, &emptytexture);

	 ZDKDisplay_SetTextureData(emptytexture, &rect, buffer, size);
	
	 if (ylEngine.horizontal) {
		int horZ = x;
		x = 272-y-height;
		y = horZ;
		horZ = width;
		width = height;
		height = horZ;
	 }

	 sprite.Color = color;
	
	 sprite.Vertices[0].X = (float)x;
	 sprite.Vertices[0].Y = (float)y;
	 sprite.Vertices[0].U = 0.0f;
	 sprite.Vertices[0].V = 0.0f;
	 sprite.Vertices[1].X = (float)(x + width);
	 sprite.Vertices[1].Y = (float)y;
	 sprite.Vertices[1].U = 1.0f;
	 sprite.Vertices[1].V = 0.0f;
	 sprite.Vertices[2].X = (float)(x + width);
	 sprite.Vertices[2].Y = (float)(y + height);
	 sprite.Vertices[2].U = 1.0f;
	 sprite.Vertices[2].V = 1.0f;
	 sprite.Vertices[3].X = (float)x;
	 sprite.Vertices[3].Y = (float)(y + height);
	 sprite.Vertices[3].U = 0.0f;
	 sprite.Vertices[3].V = 1.0f;
	
     // do the deed
	 ZDKDisplay_SetTexture(emptytexture);
     ZDKDisplay_DrawSprites(&sprite, 1);
	 ZDKDisplay_SetTexture(NULL);
	 ZDKDisplay_FreeTexture(emptytexture);
	#endif	
	#ifdef PlatformPSP
	 int wasEnable = 0;
	 OSL_LINE_VERTEX* vertices;

	 vertices = (OSL_LINE_VERTEX*)sceGuGetMemory(2 * sizeof(OSL_LINE_VERTEX));
	 color = oslBlendColor(color);

	 vertices[0].color = color;
	 vertices[0].x = x;
	 vertices[0].y = y;
	 vertices[0].z = 0;

	 vertices[1].color = color;
	 vertices[1].x = x+width;
	 vertices[1].y = y+height;
	 vertices[1].z = 0;

	 wasEnable = osl_textureEnabled;
	 oslDisableTexturing();

	 sceGuDrawArray(GU_SPRITES, GU_COLOR_8888|GU_VERTEX_16BIT|GU_TRANSFORM_2D, 2, 0, vertices);
	 sceKernelDcacheWritebackRange(vertices, 2 * sizeof(OSL_LINE_VERTEX));
	 if (wasEnable) { oslEnableTexturing(); }
	#endif
 }



////////////////
// Draw Image //
////////////////

void ylDrawImageAdv(YL_IMAGE *image, int x, int y, int width, int height, int rotation, int horizontal, float StartU, float EndU, float StartV, float EndV, DWORD color) {	
	#ifdef PlatformZune
	 ZDK_SPRITE sprite;		
	 if (horizontal) {
		 int horZ = x;
		 x = 272-y-height;
		 y = horZ;
	 }		
	 sprite.Color = color;
	 if ((rotation != 0) || (horizontal)) {
		 float xpin[4] = { StartU, EndU, EndU, StartU };
		 float ypin[4] = { StartV, StartV, EndV, EndV };
		 double angle = (rotation + (90*ylEngine.horizontal)) * (3.14159265358979323846 / 180.0);
         double sinAngle = sin(angle);
         double cosAngle = cos(angle);
		 float offsetX=(float)image->centerX/(float)width;   //Moves Image to keep with centerX
		 float offsetY=(float)image->centerY/(float)height;  //Moves Image to keep with centerX
		 int DrawZ;	   		
		 for(DrawZ=0;DrawZ<4;DrawZ++) {
			 sprite.Vertices[DrawZ].X=x + ((float)cosAngle*((xpin[DrawZ] - offsetX)*width)- (float)sinAngle*((ypin[DrawZ] - offsetY)*height)) + image->centerX;
			 sprite.Vertices[DrawZ].Y=y + ((float)sinAngle*((xpin[DrawZ] - offsetX)*width) + (float)cosAngle*((ypin[DrawZ] - offsetY)*height)) + image->centerY;
			 sprite.Vertices[DrawZ].U=xpin[DrawZ];
			 sprite.Vertices[DrawZ].V=ypin[DrawZ];
		 }

	 } 
	 else {
		 // generate zdk sprite info
		 sprite.Vertices[0].X = (float)x;
		 sprite.Vertices[0].Y = (float)y;
		 sprite.Vertices[0].U = StartU;
		 sprite.Vertices[0].V = StartV;
		 sprite.Vertices[1].X = (float)(x + width);
		 sprite.Vertices[1].Y = (float)y;
		 sprite.Vertices[1].U = EndU;
		 sprite.Vertices[1].V = StartV;
		 sprite.Vertices[2].X = (float)(x + width);
		 sprite.Vertices[2].Y = (float)(y + height);
		 sprite.Vertices[2].U = EndU;
		 sprite.Vertices[2].V = EndV;
		 sprite.Vertices[3].X = (float)x;
		 sprite.Vertices[3].Y = (float)(y + height);
		 sprite.Vertices[3].U = StartU;
		 sprite.Vertices[3].V = EndV;
	 }		
     // do the deed
     ZDKDisplay_SetTexture(image->Texture);
     ZDKDisplay_DrawSprites(&sprite, 1);
	 ZDKDisplay_SetTexture(NULL);
	#endif
	#ifdef PlatformPSP
	 //x	 
	 image->Texture->x = x + (width/2);
	 //y	 
	 image->Texture->y = y + (height/2);
	 //w+h
	 image->Texture->stretchX = width;
	 image->Texture->stretchY = height;	 
	 image->Texture->centerX = (width / 2);
	 image->Texture->centerY = (height / 2);
	 //r+ho
	 image->Texture->angle = rotation - (90-(90*horizontal));
	 //su+av+eu+ev	  
	 image->Texture->offsetX0=(float)image->Texture->sizeX * StartU; 
	 image->Texture->offsetY0=(float)image->Texture->sizeY * StartV; 
	 image->Texture->offsetX1=(float)image->Texture->sizeX * EndU;
	 image->Texture->offsetY1=(float)image->Texture->sizeY * EndV;	  
	 //image->Texture->stretchX = oslAbs((int)((float)(image->Texture->offsetX1) - (float)(image->Texture->offsetX0))),
	 //image->Texture->stretchY = oslAbs((int)((float)(image->Texture->offsetY1) - (float)(image->Texture->offsetY0)));	 
	
	 oslSetAlpha(OSL_FX_ALPHA|OSL_FX_COLOR, color);
		 
	 oslDrawImage(image->Texture);

	#endif
}
void ylDrawImage(YL_IMAGE *image, int x, int y, int rotation) {
	ylDrawImageAdv(image, x, y, image->sizeX, image->sizeY, rotation, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, 0xFFFFFFFF);
}
void ylDrawImageSimple(YL_IMAGE *image) {
	ylDrawImageAdv(image, image->X, image->Y, image->sizeX, image->sizeY, image->R, ylEngine.horizontal, 0.0f, 1.0f, 0.0f, 1.0f, 0xFFFFFFFF);
}



///////////////////
// Font Settings //
///////////////////

//For spacing use 0 for drawing from the left(Normal), 1 for drawing from the center, 2 for drawing from the right
void ylSetFont(YL_FONT *font, int size, DWORD color, int spacing) { 
	font->fontHeight = size;
	
	font->fontWidth = font->charWidth / (font->charHeight/font->fontHeight);

	font->color = color;

	font->spacing = spacing;
	
}
int ylStrWidth(YL_FONT *font, int size, char *string) {
	
	int charcount = strlen(string);
	
	return (charcount * (font->charWidth / (font->charHeight/size)));
	
}



///////////////
// Draw Font //
///////////////

void ylDrawChar(YL_FONT *font, char ch, int x, int y) {	   
	#ifdef PlatformZune
	ZDK_SPRITE sprite;	
	
	int chnum = (ch - 32);
	int line = chnum/16;
	float charUstart = 0.0f;
	float charUwidth = ((float)font->charWidth / (float)font->sizeX);
	float charVstart = ((float)(line*font->charHeight) / (float)font->sizeY);
	float charVwidth = ((float)font->charHeight / (float)font->sizeY);
	if ((ch<32) || (ch>126)) { charUstart = ((float)font->charWidth / (float)font->sizeX); charVstart = 0.0f; }
	else { charUstart = (((chnum - (line*16)) * (float)font->charWidth) / (float)font->sizeX); }
	
	if (ylEngine.horizontal) {
		int horZ = x;
		x = 272-y-font->fontHeight;
		y = horZ;
	}

	sprite.Color = font->color;
	
	if (ylEngine.horizontal){
	
		sprite.Vertices[0].X = (float)(x + font->fontHeight);
		sprite.Vertices[0].Y = (float)y;
		sprite.Vertices[0].U = charUstart;
		sprite.Vertices[0].V = charVstart;
		sprite.Vertices[1].X = (float)(x + font->fontHeight);
		sprite.Vertices[1].Y = (float)(y + font->fontWidth);
		sprite.Vertices[1].U = charUstart+charUwidth;
		sprite.Vertices[1].V = charVstart;
		sprite.Vertices[2].X = (float)x;
		sprite.Vertices[2].Y = (float)(y + font->fontWidth);
		sprite.Vertices[2].U = charUstart+charUwidth;
		sprite.Vertices[2].V = charVstart+charVwidth;
		sprite.Vertices[3].X = (float)x;
		sprite.Vertices[3].Y = (float)y;
		sprite.Vertices[3].U = charUstart;
		sprite.Vertices[3].V = charVstart+charVwidth;
	
	}
	else {
		// generate zdk sprite info
		sprite.Vertices[0].X = (float)x;
		sprite.Vertices[0].Y = (float)y;
		sprite.Vertices[0].U = charUstart;
		sprite.Vertices[0].V = charVstart;
		sprite.Vertices[1].X = (float)(x + font->fontWidth);
		sprite.Vertices[1].Y = (float)y;
		sprite.Vertices[1].U = charUstart+charUwidth;
		sprite.Vertices[1].V = charVstart;
		sprite.Vertices[2].X = (float)(x + font->fontWidth);
		sprite.Vertices[2].Y = (float)(y + font->fontHeight);
		sprite.Vertices[2].U = charUstart+charUwidth;
		sprite.Vertices[2].V = charVstart+charVwidth;
		sprite.Vertices[3].X = (float)x;
		sprite.Vertices[3].Y = (float)(y + font->fontHeight);
		sprite.Vertices[3].U = charUstart;
		sprite.Vertices[3].V = charVstart+charVwidth;

	}	
	
    ZDKDisplay_SetTexture(font->Texture);
    ZDKDisplay_DrawSprites(&sprite, 1);
	ZDKDisplay_SetTexture(NULL);
	#endif
	#ifdef PlatformPSP
	int chnum = (ch - 32);
	int line = chnum/16;
	float charUstart = 0.0f;
	float charUwidth = ((float)font->charWidth / (float)font->Texture->sizeX);
	float charVstart = ((float)(line*font->charHeight) / (float)font->Texture->sizeY);
	float charVwidth = ((float)font->charHeight / (float)font->Texture->sizeY);
	if ((ch<32) || (ch>126)) { charUstart = ((float)font->charWidth / (float)font->Texture->sizeX); charVstart = 0.0f; }
	else { charUstart = (((chnum - (line*16)) * (float)font->charWidth) / (float)font->Texture->sizeX); }
	
	 //x	 
	 font->Texture->x = x + (font->fontWidth/2);
	 //y	 
	 font->Texture->y = y + (font->fontHeight/2);
	 //w+h
	 font->Texture->stretchX = font->fontWidth;
	 font->Texture->stretchY = font->fontHeight;	 
	 font->Texture->centerX = (font->fontWidth / 2);
	 font->Texture->centerY = (font->fontHeight / 2);
	 //r+ho
	 //font->Texture->angle = rotation - (90-(90*horizontal));
	 //su+av+eu+ev	  
	 font->Texture->offsetX0=(float)font->Texture->sizeX * charUstart; 
	 font->Texture->offsetY0=(float)font->Texture->sizeY * charVstart; 
	 font->Texture->offsetX1=(float)font->Texture->sizeX * (charUstart+charUwidth);
	 font->Texture->offsetY1=(float)font->Texture->sizeY * (charVstart+charVwidth);	  
	 //font->Texture->stretchX = oslAbs((int)((float)(font->Texture->offsetX1) - (float)(font->Texture->offsetX0))),
	 //font->Texture->stretchY = oslAbs((int)((float)(image->Texture->offsetY1) - (float)(font->Texture->offsetY0)));	

	 oslSetAlpha(OSL_FX_ALPHA|OSL_FX_COLOR, font->color);
	 
	 oslDrawImage(font->Texture);	
	#endif
}
void ylDrawString(YL_FONT *font, char *string, int x, int y) {
	int DrawZ;
	for(DrawZ=0;string[DrawZ]!='\0';DrawZ++)
	{
		int AltX = 0;
		BOOL isLastLetter = 0;
		
		if(string[DrawZ]=='\n'&&string[DrawZ+1]=='\0') { break; }
			
		if (font->spacing == 0) {
			AltX = x;
		}
		else if (font->spacing == 1) {
			AltX = x - (ylStrWidth(font, font->fontHeight, string)/2);
		}
		else if (font->spacing == 2) {
			AltX = x - (ylStrWidth(font, font->fontHeight, string));
		}

		isLastLetter = (AltX + font->fontWidth >= ylEngine.scwidth);
		
		//Prevents drawing past the screen but not before it, improve.
		if ((AltX<ylEngine.scwidth+font->fontWidth) && (AltX>0-font->fontWidth) && (y<ylEngine.scheight+font->fontWidth) && (y>0-font->fontWidth)) {
			ylDrawChar(font, string[DrawZ], AltX, y);	
		}

		x+=font->fontWidth;



		if(isLastLetter) { break; }
	}
}


//////////////
// Controls //
//////////////

void ylReadInput() {
	#ifdef PlatformZune
	 //Read Input				
	 lastinput = input;
	 ZDKInput_GetState(&input);
	 if (ylEngine.horizontal) {				
		int InputZ;
		for (InputZ=0;InputZ<4;InputZ++) {
			float LocZ = input.TouchState.Locations[InputZ].Y;
			input.TouchState.Locations[InputZ].Y = 272-input.TouchState.Locations[InputZ].X;
			input.TouchState.Locations[InputZ].X = LocZ;
		}	
	 }
	#endif
	#ifdef PlatformPSP
	 lastinput = input;
	 sceCtrlReadBufferPositive(&input, 1); 
	#endif
}

/////////////
// Network //
/////////////

void ylSetNonBlocking(int NetSocket) { 
	#ifdef PlatformZune
	 ioctlsocket(NetSocket,FIONBIO,&iMode); 
	#endif
	#ifdef PlatformPSP
	 fcntl(NetSocket, F_SETFL, O_NONBLOCK);
	#endif
}

#ifdef PlatformZune
int ylSocketCreate(void) {
	int sock;
	sock = socket(PF_INET, SOCK_STREAM, 0);		
	if(sock < 0) { return -1; }
	return sock;
}

int ylSocketConnect(int socket, char *ip, unsigned short port) {
	struct sockaddr_in addr;
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
	addr.sin_addr.S_un.S_addr = inet_addr(ip);
	memset(&(addr.sin_zero), '\0', 8);	
	bind(socket, (struct sockaddr *)&addr, sizeof(struct sockaddr));
	if(connect(socket, (struct sockaddr *)&addr, sizeof(addr)) < 0) { return 0; }		
	return 1;
}

int ylSocketSend(int socket, const void *data, int length) {
	int bytessent = send(socket, data, length, 0);
	return bytessent;
}

int ylSocketReceive(int socket, void *data, int length) {
	int bytesrecv = recv(socket, data, length, 0);
	return bytesrecv;
}
void ylSocketClose(int socket) { 
	#ifdef PlatformPSP
	 close(socket);	
	#endif
	#ifdef PlatformZune
	 closesocket(socket);
	#endif
}
#endif

