//YamaLib
//Version Beta 0.1.0.0
//(AlphaVer.MajorUpdateVer.MinorUpdateVer.CurrentBuild)
/* Information
 Created by Yamagushi
 On 7/15/10

 Latest Update
 On 10/11/10*/
 
 
/////////////////////
// Select Platform //
/////////////////////

//#define PlatformZune 1
#define PlatformPSP 1



//////////////
// Includes //
//////////////

#ifdef PlatformZune

 #include <windows.h>
 #include <winsock2.h>
 #include <zdk.h>
 #include <math.h>
 #include <time.h>

#endif

#ifdef PlatformPSP

 #include <oslib/oslib.h>
 #include <psprtc.h> 
 #include <fcntl.h>
 #include <stdarg.h>
 
 typedef int BOOL;
 typedef unsigned int DWORD;
 
#endif


bool ylPSPNetConfig;
#ifdef PlatformPSP
pspUtilityNetconfData ylNetData;
struct pspUtilityNetconfAdhoc adhocparam;
#endif

////////////////
// Structures //
////////////////

//YamaLib Structure
struct ylEngineStruct {	
	BOOL debug;
	BOOL horizontal;	
	int scheight;
	int scwidth;	
} ylEngine;

//Platform Specific
#ifdef PlatformPSP
 struct TimeStruct {
 	float fps;
  	u32 resolution;
 	u64 new;
 	u64 old;
 	u64 ticks; 
 	u32 totalframes;
 	u32 frames; 	
 } Time;
 SceCtrlData lastinput;
 SceCtrlData input;
#endif
#ifdef PlatformZune
 u_long iMode;
 //Net Configurations
 struct timeval YNnoblocktv;
 fd_set YNreadfds;
 ZDK_INPUT_STATE lastinput, input;
 extern __inline BOOL ZDKExt_ExitRequested();
#endif

//Image Structure
typedef struct {
	#ifdef PlatformZune 
	 HTEXTURE Texture;	
	 wchar_t *location;
	#endif
	#ifdef PlatformPSP
	 OSL_IMAGE *Texture; 
	 char location[50];	 
	#endif
	 int X, Y;
	 int R;
	 int sizeX, sizeY;
	 int centerX, centerY;
} YL_IMAGE; 
//Font Structure
typedef struct {
	#ifdef PlatformZune
	 HTEXTURE Texture;	
	 wchar_t *location;
	#endif
	#ifdef PlatformPSP
	 OSL_IMAGE *Texture; 
	 char location[50];	 
	#endif
	 int X, Y;
	 int sizeX, sizeY;
	 int centerX, centerY;
	 int charWidth, charHeight;
	 int fontWidth, fontHeight;
	 DWORD color;	
	 int spacing;
} YL_FONT; 

//Colors Structure
 struct ColorsSrtuct {
	 DWORD RED;
	 DWORD GREEN;
	 DWORD BLUE;
	 DWORD YELLOW;
	 DWORD ORANGE;
	 DWORD BROWN;
	 DWORD PURPLE;
	 DWORD WHITE;
	 DWORD LITEGRAY;
	 DWORD GRAY;
	 DWORD DARKGRAY;
	 DWORD BLACK;
	 DWORD filterBLACK;
 } colors;


///////////////
// Variables //
///////////////

//Main Kill Switch
BOOL YL_QUIT;



//////////////////
// Declarations //
//////////////////

//System
void CODERED(char *reason);
int ylSetupCallbacks();
void InitYamaLib();
void ylSetOrientation(int orientation);
void UnitYamaLib();
void ylsnprint(char *out, int max, char *in);

//Temporarily Platform specific
#ifdef PlatformPSP
 void Sleep(int milliseconds);
 void ylUpdateTime(float FpsLimit);
 struct oslNetConfig YNconfigs[OSL_MAX_NET_CONFIGS];
 int YNnumconfigs;
 int YNaccesspoint;
#endif

//Loading Images
int ylLoadImagePNG(YL_IMAGE *image, char *filename);
int ylLoadFontPNG(YL_FONT *font, char *filename);

//Start/End Frames
#ifdef PlatformZune
 #define ylStartDrawing ZDKDisplay_BeginScene
#endif	
#ifdef PlatformPSP
 #define ylStartDrawing oslStartDrawing
#endif

void ylEndDrawing();

#ifdef PlatformZune
 #define ylSyncFrame ZDKDisplay_Present
#endif	
#ifdef PlatformPSP
 #define ylSyncFrame oslSyncFrame
#endif
void ylClearScreen();

//Draw Rectangle
 void ylDrawRect(int x, int y, int width, int height, DWORD color);

//Draw Image
void ylDrawImageAdv(YL_IMAGE *image, int x, int y, int width, int height, int rotation, int horizontal, float StartU, float EndU, float StartV, float EndV, DWORD color);
void ylDrawImage(YL_IMAGE *image, int x, int y, int rotation);
void ylDrawImageSimple(YL_IMAGE *image);

//Font Settings
void ylSetFont(YL_FONT *font, int size, DWORD color, int spacing);
int ylStrWidth(YL_FONT *font, int size, char *string);

//Draw Font
void ylDrawString(YL_FONT *font, char *string, int x, int y);



//////////////
// Controls //
//////////////

void ylReadInput();

#ifdef PlatformPSP
int YNconnectAPCallback(int state);
int YNconnectToAP(int YNconToAPconfig);
#endif



/////////////
// Network //
/////////////

 void ylSetNonBlocking();
 void ylPSPNetConf();
#ifdef PlatformZune
 int ylSocketCreate(void);
 int ylSocketConnect(int socket, char  *ip, unsigned short port);
 int ylSocketSend(int socket, const void *data, int  length);
 int ylSocketReceive(int socket, void *data, int length);
 void ylSocketClose(int socket);
#endif
#ifdef PlatformPSP
 #define ylSocketCreate oslNetSocketCreate
 #define ylSocketConnect oslNetSocketConnect
 #define ylSocketSend oslNetSocketSend
 #define ylSocketReceive oslNetSocketReceive
 #define ylSocketClose oslNetSocketClose
#endif

///////////
// OTHER //
///////////
#ifdef PlatformZune
 #define snprintf _snprintf
 #define vsnprintf _vsnprintf
 #define strncmpi _strnicmp
 #define strcmpi _stricmp
#endif