// YamaIRC
// Version Alpha 5.0.0.0
//(AlphaVer.MajorUpdateVer.MinorUpdateVer.CurrentBuild)
/* Information
 Created by Yamagushi
 On 7/15/10

 Latest Noted Update
 On 12/11/10*/
 
#include "YamaLib.h"



//Structures
struct EngineStruct {   //Engine Struct.
	BOOL debug;   //Whether or not the Engine is in Debug Mode.
	int z;   //Global For Loop Variable.
	int z2;   //Global For Loop Variable.
	char buffer[513];   //Global Buffer.
	int frameskip;   //Global Frameskip.
	int numchans;   //Number of Open Channels.
} Engine;

struct NetworkStruct {   //Network Struct.
	BOOL wlan;   //Status of the WLAN. (0-Off,1-On)
	int status;   //Status of the Network. (0-Off,1-On)
	char server[16];   //Current Server.
	unsigned short port;   //Current Port.
	int socket;   //Current Socket.
	int maxsocket;   //Max Socket.
	int readbytes;   //Keeps Track of Bytes Read in recv.
	BOOL activity;   //Flag for displaying internet Activity.
	int activityfs;   //Frameskip for displaying internet Activity.
	char ircupdatebuff[1024];   //Buffer for IRCUpdate.
	int ircupdatebuffsize;	   //Buffer Size for IRCUpdate.	
	char opdelimiters[26];   //Delimiters for Op Sign Removal.
	int numdelimiters;   //Number of Op Signs.
} Network;

struct ChannelStruct {   //Channel Structures
	char name[51]; //Name of the Channel, Check Size #DEBUG#
	int numusers; //Number of Users In the Channel
	char *user[10000]; //Pointers to malloc'd user names.	
	BOOL newmessage;   //Whether there are any new messages.		
	char messagebuffer[513]; //Buffer for Proccessing.
	int messtype[50]; //Type of Message.
	char *messto[50]; //Message Destination.
	char *messuser1[50]; //Message User 1.
	char *messuser2[50]; //Message User 2.
	char *messuser3[50]; //Message User 3.
	char *message1[50]; //Message 1.
	char *message2[50]; //Message 2.
	
} *OpenChannel, MyChannel, SystemChannel, RawChannel, DebugChannel, *Channel[100];

struct UIStruct {   //UI Struct.
	BOOL chathscroll;   //Whether or not Horizontal Scrolling is on. (Zune Only)
	BOOL chatvscroll;   //Whether or not Vertical Scrolling is on. (Zune Only)
	int chatvpos;   //The Vertical Position of the Chat.
	int chatpos;   //The Horizontal?? Position of the Chat.
	int chatoffset;   //Chat UI offset for Scrolling.
	int chatcuroffset;   //Chat UI offset for Scrolling.
	int chatlen;   //Length of the Max Visible String.
	BOOL settingsscroll;
	int settingspos;   //The Horizontal?? Position of the Chat.
	int settingsoffset;   //Chat UI offset for Scrolling.
	int settingscuroffset;   //Chat UI offset for Scrolling.
} UI;

struct MenuStruct { //Menu Structs.
	int level; //Menu Level.
	int selected; //Menu Item Currently Selected.
	int user; //User Currently Selected.
} MainMenu, PauseMenu;

struct SettingsStruct {   //Settings Struct.
	BOOL isactive;   //Setting Menu Open/Close.
	BOOL runonce;   //Run Once for Original Menu, Possible to Remove. #UPGRADE#	
	BOOL kbauto;   //Whether or not Keyboard AutoComplete is on. (Zune Only)
	int fontsize;   //Size of the Font.
	BOOL kbbutton;   //Keyboard Button in Main Chat. (Zune Only)
} Settings;

struct PopUpStruct {   //PopUp Struct.
	BOOL isactive;   //PopUp Menu Open/Close.
	char name[51];   //PopUp Name.
	char reason[151]; //PopUp Reason.
} PopUp;

//Save Info
struct SaveStuct { 
	char mynickname[17];   //Saved Nickname.
	char mychannel[50];   //Saved Channel.
	char myserver[100];   //Saved Server.
	char myport[10];   //Saved Port.
	int accesspoint;   //Saved Access Point.
} SaveData;

struct KeyBoardStruct {   //Keyboard Struct.
	BOOL isactive;   //Whether the Keyboard is Active.
	BOOL edited;   //Whether the Keyboard has been Edited. (Alt Use on PSP) #UPGRADE#
	int type;   //Type of Keyboard to Launch.
	char keybuffer[513];   //Keyboard Output Buffer.
	#ifdef PlatformZune
	 ZDK_KEYBOARD_STATE state;	//Zune OSK State. #UPGRADE#
	 size_t outputlength;   //Zune Output Length. #UPGRADE#
	#endif
} Keyboard;

//Images 
YL_IMAGE Logo;
YL_IMAGE Selected;
YL_IMAGE Cursor1;
YL_IMAGE Cursor2;
YL_IMAGE Cursor3;
YL_IMAGE ABCCursor;
YL_IMAGE ScrollCursor;
YL_IMAGE ScrollBkg;
YL_IMAGE SettingsBtn;
YL_IMAGE SettingsMore;
YL_IMAGE SettingsOn;
YL_IMAGE SettingsOff;
YL_IMAGE MessageCursor;


//Fonts
YL_FONT DefaultFont;

//Declarations

//Main

//Menu/UI
void MenuUI();   //Runs the Menu UI.

//IRC/UI
void IRCUI();   //Runs the IRC UI.
void SettingsUI();   //Runs Settings UI.
void PopUpUI();   //Runs Error Pop Up UI.

//Menu/Controls
void MenuControls();  //Runs Menu Controls.

//IRC/Controls
void IRCControls();   //Runs IRC Controls.
void SettingsControls();   //Runs Settings Controls.
void PopUpControls();   //Runs Error Pop Up Controls.

//Engine
void EngineInit();   //Initiates the Engine.
void ResetEngine();   //Reinitiates the Engine.
void QuitEngine();    //Quits the Engine.
void LaunchPopUp(char *name, char *reason);   //Launches Error Pop UP
void LogRaw(char *data);   //Logs raw Data.
void LogChat(int dest, int messtype, char *messto, char *messuser1, char *messuser2, char *messuser3, char *messmessage1, char *messmessage2);   //Logs Chat Messages
void raw(char *fmt, ...);   //Sends a Raw Message to the Server.
void IRCLogin();   //Logs Into the IRC Server.
int IRCUpdate();   //Updates the IRC.

//Process
void ParseIncoming(char *data);   //Processes Incoming Data.
void ProcessOutgoing(int proctype, char *whereto, char *message);   //Processes Outgoing Data.

//Other
void RunKeyboard();   //Runs the On Screen Keyboard.